"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _extend = require("extend");

var _extend2 = _interopRequireDefault(_extend);

var _util = require("util.react");

var _util2 = _interopRequireDefault(_util);

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

var _reactSpreadProps = require("react-spread-props");

var _reactSpreadProps2 = _interopRequireDefault(_reactSpreadProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('./index.css');

var Checkbox = function (_Component) {
    _inherits(Checkbox, _Component);

    function Checkbox(props) {
        _classCallCheck(this, Checkbox);

        var _this = _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props));

        _this.onFocus = function () {
            _this.setState({
                focus: true
            });
        };

        _this.onBlur = function () {
            _this.setState({
                focus: false
            });
        };

        var self = _this;
        _this.state = {
            focus: false
        };
        return _this;
    }

    _createClass(Checkbox, [{
        key: "render",
        value: function render() {
            var _cls;

            var self = this;
            var pcls = self.props.prefixClassName;
            var rootClassName = [pcls, _util2.default.themes(self.props)].join(' ');

            var domProps = (0, _reactSpreadProps2.default)(self.props, {
                className: rootClassName + (0, _classnames2.default)((_cls = {}, _defineProperty(_cls, "" + rootClassName, true), _defineProperty(_cls, pcls + "--checked", self.props.checked), _defineProperty(_cls, pcls + "--disabled", self.props.disabled), _defineProperty(_cls, pcls + "--focus", self.state.focus), _cls))
            });

            var beforeType = _typeof(self.props.before);

            return require("react").createElement(
                "label",
                _extends({
                    ref: function ref(node) {
                        return self.refRoot = node;
                    }
                }, domProps),
                self.props.before === true ? require("react").createElement(
                    "span",
                    { className: pcls + "-label" },
                    self.props.children
                ) : beforeType === 'string' || beforeType === 'object' ? require("react").createElement(
                    "span",
                    { className: pcls + "-label" },
                    self.props.before
                ) : null,
                require("react").createElement(
                    "span",
                    { className: pcls + "-switch" },
                    require("react").createElement("span", { className: pcls + "-switch-icon" }),
                    require("react").createElement("input", {
                        name: self.props.name,
                        value: self.props.value,
                        checked: self.props.checked,
                        type: self.props.type,
                        disabled: self.props.disabled,
                        onChange: self.props.onChange,
                        className: pcls + "-switch-input",
                        onFocus: self.onFocus,
                        onBlur: self.onBlur
                    })
                ),
                beforeType && self.props.before === true ? null : require("react").createElement(
                    "span",
                    { className: pcls + "-label" },
                    self.props.children
                )
            );
        }
    }]);

    return Checkbox;
}(_react.Component);

require('./props').default(Checkbox);
exports.default = Checkbox;

module.exports = Checkbox;